using System;
using System.Windows.Forms;
using GTA;

namespace TestScriptCS {
Player CustomFiberThread::GetPlayer()
{
	Player playerIndex = ConvertIntToPlayerIndex(GetPlayerId());
	return playerIndex;
}

Scripting::Ped CustomFiberThread::GetPlayerPed()
{
	Ped ped;
	GetPlayerChar(GetPlayer(), &ped);
	return ped;
}

Scripting::Vehicle CustomFiberThread::GetPlayerVehicle()
{
	Vehicle playervehicle;
	GetCarCharIsUsing(GetPlayerPed(), &playervehicle);
	return playervehicle;
}

bool CustomFiberThread::Tow()
{
	Vehicle v = GetPlayerVehicle();
	if (!DoesVehicleExist(v)) return false;

	if (IsCarAttached(v))
	{
		LogInfo("TowTruck: Detaching Vehicle");
		DetachCar(v);
		return false;
	}
	else
	{
		f32 x,y,z;
		GetCharCoordinates(GetPlayerPed(), &x, &y, &z);
		Vehicle towv = GetClosestCar(x,y,z,7.5F,false,70);
		if (!DoesVehicleExist(towv)) return false;
		LogInfo("TowTruck: Attaching Vehicle");
		//AttachCarToCarPhysically(towv, v, false, 0, yoff, xoff, zoff, xbuff, ybuff, zbuff, xrotv1, yrotv1,0.0F,0.0F,0.0F);
		AttachCarToCarPhysically(v,towv, false, 0, 0.0F, 6.0F, -0.01F, 0.001F, 0.1F, 0.1F, 0.0F, 0.0F,0.0F,0.0F,0.0F);
		Wait(100);
		AttachCarToCarPhysically(v,towv, false, 0, 0.0F, 5.3F, -0.8F, 0.001F, 0.1F, 0.1F, -0.1F, 0.0F,0.0F,0.0F,0.0F);
		return true;
	}
	return true;
}

void CustomFiberThread::RunScript()
{
	while(IsThreadAlive())
	{
		if ((GetAsyncKeyState(VK_END) & 1) != 0)
		{
			Tow();
		}
		Wait(100);
	}
TERMINATE_THIS_SCRIPT();
    return;
}
}

